// modules are defined as an array
// [ module function, map of requires ]
//
// map of requires is short require name -> numeric require
//
// anything defined in a previous bundle is accessed via the
// orig method which is the require for previous bundles
parcelRequire = (function (modules, cache, entry, globalName) {
  // Save the require from previous bundle to this closure if any
  var previousRequire = typeof parcelRequire === 'function' && parcelRequire;
  var nodeRequire = typeof require === 'function' && require;

  function newRequire(name, jumped) {
    if (!cache[name]) {
      if (!modules[name]) {
        // if we cannot find the module within our internal map or
        // cache jump to the current global require ie. the last bundle
        // that was added to the page.
        var currentRequire = typeof parcelRequire === 'function' && parcelRequire;
        if (!jumped && currentRequire) {
          return currentRequire(name, true);
        }

        // If there are other bundles on this page the require from the
        // previous one is saved to 'previousRequire'. Repeat this as
        // many times as there are bundles until the module is found or
        // we exhaust the require chain.
        if (previousRequire) {
          return previousRequire(name, true);
        }

        // Try the node require function if it exists.
        if (nodeRequire && typeof name === 'string') {
          return nodeRequire(name);
        }

        var err = new Error('Cannot find module \'' + name + '\'');
        err.code = 'MODULE_NOT_FOUND';
        throw err;
      }

      localRequire.resolve = resolve;
      localRequire.cache = {};

      var module = cache[name] = new newRequire.Module(name);

      modules[name][0].call(module.exports, localRequire, module, module.exports, this);
    }

    return cache[name].exports;

    function localRequire(x){
      return newRequire(localRequire.resolve(x));
    }

    function resolve(x){
      return modules[name][1][x] || x;
    }
  }

  function Module(moduleName) {
    this.id = moduleName;
    this.bundle = newRequire;
    this.exports = {};
  }

  newRequire.isParcelRequire = true;
  newRequire.Module = Module;
  newRequire.modules = modules;
  newRequire.cache = cache;
  newRequire.parent = previousRequire;
  newRequire.register = function (id, exports) {
    modules[id] = [function (require, module) {
      module.exports = exports;
    }, {}];
  };

  var error;
  for (var i = 0; i < entry.length; i++) {
    try {
      newRequire(entry[i]);
    } catch (e) {
      // Save first error but execute all entries
      if (!error) {
        error = e;
      }
    }
  }

  if (entry.length) {
    // Expose entry point to Node, AMD or browser globals
    // Based on https://github.com/ForbesLindesay/umd/blob/master/template.js
    var mainExports = newRequire(entry[entry.length - 1]);

    // CommonJS
    if (typeof exports === "object" && typeof module !== "undefined") {
      module.exports = mainExports;

    // RequireJS
    } else if (typeof define === "function" && define.amd) {
     define(function () {
       return mainExports;
     });

    // <script>
    } else if (globalName) {
      this[globalName] = mainExports;
    }
  }

  // Override the current require with this new one
  parcelRequire = newRequire;

  if (error) {
    // throw error from earlier, _after updating parcelRequire_
    throw error;
  }

  return newRequire;
})({"1aSo":[function(require,module,exports) {
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.render = I;
exports.hydrate = L;
exports.h = exports.createElement = h;
exports.Fragment = d;
exports.createRef = p;
exports.Component = m;
exports.cloneElement = M;
exports.createContext = O;
exports.toChildArray = x;
exports._unmount = D;
exports.options = exports.isValidElement = void 0;
var n,
    l,
    u,
    t,
    i,
    r,
    o,
    f = {},
    e = [],
    c = /acit|ex(?:s|g|n|p|$)|rph|grid|ows|mnc|ntw|ine[ch]|zoo|^ord|^--/i;
exports.isValidElement = l;
exports.options = n;

function s(n, l) {
  for (var u in l) n[u] = l[u];

  return n;
}

function a(n) {
  var l = n.parentNode;
  l && l.removeChild(n);
}

function h(n, l, u) {
  var t,
      i,
      r,
      o,
      f = arguments;
  if (l = s({}, l), arguments.length > 3) for (u = [u], t = 3; t < arguments.length; t++) u.push(f[t]);
  if (null != u && (l.children = u), null != n && null != n.defaultProps) for (i in n.defaultProps) void 0 === l[i] && (l[i] = n.defaultProps[i]);
  return o = l.key, null != (r = l.ref) && delete l.ref, null != o && delete l.key, v(n, l, o, r);
}

function v(l, u, t, i) {
  var r = {
    type: l,
    props: u,
    key: t,
    ref: i,
    __k: null,
    __p: null,
    __b: 0,
    __e: null,
    l: null,
    __c: null,
    constructor: void 0
  };
  return n.vnode && n.vnode(r), r;
}

function p() {
  return {};
}

function d(n) {
  return n.children;
}

function y(n) {
  if (null == n || "boolean" == typeof n) return null;
  if ("string" == typeof n || "number" == typeof n) return v(null, n, null, null);

  if (null != n.__e || null != n.__c) {
    var l = v(n.type, n.props, n.key, null);
    return l.__e = n.__e, l;
  }

  return n;
}

function m(n, l) {
  this.props = n, this.context = l;
}

function w(n, l) {
  if (null == l) return n.__p ? w(n.__p, n.__p.__k.indexOf(n) + 1) : null;

  for (var u; l < n.__k.length; l++) if (null != (u = n.__k[l]) && null != u.__e) return u.__e;

  return "function" == typeof n.type ? w(n) : null;
}

function g(n) {
  var l, u;

  if (null != (n = n.__p) && null != n.__c) {
    for (n.__e = n.__c.base = null, l = 0; l < n.__k.length; l++) if (null != (u = n.__k[l]) && null != u.__e) {
      n.__e = n.__c.base = u.__e;
      break;
    }

    return g(n);
  }
}

function k(l) {
  (!l.__d && (l.__d = !0) && 1 === u.push(l) || i !== n.debounceRendering) && (i = n.debounceRendering, (n.debounceRendering || t)(_));
}

function _() {
  var n, l, t, i, r, o, f, e;

  for (u.sort(function (n, l) {
    return l.__v.__b - n.__v.__b;
  }); n = u.pop();) n.__d && (t = void 0, i = void 0, o = (r = (l = n).__v).__e, f = l.__P, e = l.u, l.u = !1, f && (t = [], i = $(f, r, s({}, r), l.__n, void 0 !== f.ownerSVGElement, null, t, e, null == o ? w(r) : o), j(t, r), i != o && g(r)));
}

function b(n, l, u, t, i, r, o, c, s) {
  var h,
      v,
      p,
      d,
      y,
      m,
      g,
      k = u && u.__k || e,
      _ = k.length;
  if (c == f && (c = null != r ? r[0] : _ ? w(u, 0) : null), h = 0, l.__k = x(l.__k, function (u) {
    if (null != u) {
      if (u.__p = l, u.__b = l.__b + 1, null === (p = k[h]) || p && u.key == p.key && u.type === p.type) k[h] = void 0;else for (v = 0; v < _; v++) {
        if ((p = k[v]) && u.key == p.key && u.type === p.type) {
          k[v] = void 0;
          break;
        }

        p = null;
      }

      if (d = $(n, u, p = p || f, t, i, r, o, null, c, s), (v = u.ref) && p.ref != v && (g || (g = [])).push(v, u.__c || d, u), null != d) {
        if (null == m && (m = d), null != u.l) d = u.l, u.l = null;else if (r == p || d != c || null == d.parentNode) {
          n: if (null == c || c.parentNode !== n) n.appendChild(d);else {
            for (y = c, v = 0; (y = y.nextSibling) && v < _; v += 2) if (y == d) break n;

            n.insertBefore(d, c);
          }

          "option" == l.type && (n.value = "");
        }
        c = d.nextSibling, "function" == typeof l.type && (l.l = d);
      }
    }

    return h++, u;
  }), l.__e = m, null != r && "function" != typeof l.type) for (h = r.length; h--;) null != r[h] && a(r[h]);

  for (h = _; h--;) null != k[h] && D(k[h], k[h]);

  if (g) for (h = 0; h < g.length; h++) A(g[h], g[++h], g[++h]);
}

function x(n, l, u) {
  if (null == u && (u = []), null == n || "boolean" == typeof n) l && u.push(l(null));else if (Array.isArray(n)) for (var t = 0; t < n.length; t++) x(n[t], l, u);else u.push(l ? l(y(n)) : n);
  return u;
}

function C(n, l, u, t, i) {
  var r;

  for (r in u) r in l || N(n, r, null, u[r], t);

  for (r in l) i && "function" != typeof l[r] || "value" === r || "checked" === r || u[r] === l[r] || N(n, r, l[r], u[r], t);
}

function P(n, l, u) {
  "-" === l[0] ? n.setProperty(l, u) : n[l] = "number" == typeof u && !1 === c.test(l) ? u + "px" : null == u ? "" : u;
}

function N(n, l, u, t, i) {
  var r, o, f, e, c;
  if ("key" === (l = i ? "className" === l ? "class" : l : "class" === l ? "className" : l) || "children" === l) ;else if ("style" === l) {
    if (r = n.style, "string" == typeof u) r.cssText = u;else {
      if ("string" == typeof t && (r.cssText = "", t = null), t) for (o in t) u && o in u || P(r, o, "");
      if (u) for (f in u) t && u[f] === t[f] || P(r, f, u[f]);
    }
  } else "o" === l[0] && "n" === l[1] ? (e = l !== (l = l.replace(/Capture$/, "")), c = l.toLowerCase(), l = (c in n ? c : l).slice(2), u ? (t || n.addEventListener(l, T, e), (n.t || (n.t = {}))[l] = u) : n.removeEventListener(l, T, e)) : "list" !== l && "tagName" !== l && "form" !== l && !i && l in n ? n[l] = null == u ? "" : u : "function" != typeof u && "dangerouslySetInnerHTML" !== l && (l !== (l = l.replace(/^xlink:?/, "")) ? null == u || !1 === u ? n.removeAttributeNS("http://www.w3.org/1999/xlink", l.toLowerCase()) : n.setAttributeNS("http://www.w3.org/1999/xlink", l.toLowerCase(), u) : null == u || !1 === u ? n.removeAttribute(l) : n.setAttribute(l, u));
}

function T(l) {
  return this.t[l.type](n.event ? n.event(l) : l);
}

function $(l, u, t, i, r, o, f, e, c, a) {
  var h,
      v,
      p,
      y,
      w,
      g,
      k,
      _,
      C,
      P,
      N = u.type;

  if (void 0 !== u.constructor) return null;
  (h = n.__b) && h(u);

  try {
    n: if ("function" == typeof N) {
      if (_ = u.props, C = (h = N.contextType) && i[h.__c], P = h ? C ? C.props.value : h.__p : i, t.__c ? k = (v = u.__c = t.__c).__p = v.__E : ("prototype" in N && N.prototype.render ? u.__c = v = new N(_, P) : (u.__c = v = new m(_, P), v.constructor = N, v.render = H), C && C.sub(v), v.props = _, v.state || (v.state = {}), v.context = P, v.__n = i, p = v.__d = !0, v.__h = []), null == v.__s && (v.__s = v.state), null != N.getDerivedStateFromProps && s(v.__s == v.state ? v.__s = s({}, v.__s) : v.__s, N.getDerivedStateFromProps(_, v.__s)), p) null == N.getDerivedStateFromProps && null != v.componentWillMount && v.componentWillMount(), null != v.componentDidMount && f.push(v);else {
        if (null == N.getDerivedStateFromProps && null == e && null != v.componentWillReceiveProps && v.componentWillReceiveProps(_, P), !e && null != v.shouldComponentUpdate && !1 === v.shouldComponentUpdate(_, v.__s, P)) {
          for (v.props = _, v.state = v.__s, v.__d = !1, v.__v = u, u.__e = null != c ? c !== t.__e ? c : t.__e : null, u.__k = t.__k, h = 0; h < u.__k.length; h++) u.__k[h] && (u.__k[h].__p = u);

          break n;
        }

        null != v.componentWillUpdate && v.componentWillUpdate(_, v.__s, P);
      }

      for (y = v.props, w = v.state, v.context = P, v.props = _, v.state = v.__s, (h = n.__r) && h(u), v.__d = !1, v.__v = u, v.__P = l, h = v.render(v.props, v.state, v.context), u.__k = x(null != h && h.type == d && null == h.key ? h.props.children : h), null != v.getChildContext && (i = s(s({}, i), v.getChildContext())), p || null == v.getSnapshotBeforeUpdate || (g = v.getSnapshotBeforeUpdate(y, w)), b(l, u, t, i, r, o, f, c, a), v.base = u.__e; h = v.__h.pop();) v.__s && (v.state = v.__s), h.call(v);

      p || null == y || null == v.componentDidUpdate || v.componentDidUpdate(y, w, g), k && (v.__E = v.__p = null);
    } else u.__e = z(t.__e, u, t, i, r, o, f, a);

    (h = n.diffed) && h(u);
  } catch (l) {
    n.__e(l, u, t);
  }

  return u.__e;
}

function j(l, u) {
  for (var t; t = l.pop();) try {
    t.componentDidMount();
  } catch (l) {
    n.__e(l, t.__v);
  }

  n.__c && n.__c(u);
}

function z(n, l, u, t, i, r, o, c) {
  var s,
      a,
      h,
      v,
      p = u.props,
      d = l.props;
  if (i = "svg" === l.type || i, null == n && null != r) for (s = 0; s < r.length; s++) if (null != (a = r[s]) && (null === l.type ? 3 === a.nodeType : a.localName === l.type)) {
    n = a, r[s] = null;
    break;
  }

  if (null == n) {
    if (null === l.type) return document.createTextNode(d);
    n = i ? document.createElementNS("http://www.w3.org/2000/svg", l.type) : document.createElement(l.type), r = null;
  }

  return null === l.type ? p !== d && (null != r && (r[r.indexOf(n)] = null), n.data = d) : l !== u && (null != r && (r = e.slice.call(n.childNodes)), h = (p = u.props || f).dangerouslySetInnerHTML, v = d.dangerouslySetInnerHTML, c || (v || h) && (v && h && v.__html == h.__html || (n.innerHTML = v && v.__html || "")), C(n, d, p, i, c), l.__k = l.props.children, v || b(n, l, u, t, "foreignObject" !== l.type && i, r, o, f, c), c || ("value" in d && void 0 !== d.value && d.value !== n.value && (n.value = null == d.value ? "" : d.value), "checked" in d && void 0 !== d.checked && d.checked !== n.checked && (n.checked = d.checked))), n;
}

function A(l, u, t) {
  try {
    "function" == typeof l ? l(u) : l.current = u;
  } catch (l) {
    n.__e(l, t);
  }
}

function D(l, u, t) {
  var i, r, o;

  if (n.unmount && n.unmount(l), (i = l.ref) && A(i, null, u), t || "function" == typeof l.type || (t = null != (r = l.__e)), l.__e = l.l = null, null != (i = l.__c)) {
    if (i.componentWillUnmount) try {
      i.componentWillUnmount();
    } catch (l) {
      n.__e(l, u);
    }
    i.base = i.__P = null;
  }

  if (i = l.__k) for (o = 0; o < i.length; o++) i[o] && D(i[o], u, t);
  null != r && a(r);
}

function H(n, l, u) {
  return this.constructor(n, u);
}

function I(l, u, t) {
  var i, o, c;
  n.__p && n.__p(l, u), o = (i = t === r) ? null : t && t.__k || u.__k, l = h(d, null, [l]), c = [], $(u, i ? u.__k = l : (t || u).__k = l, o || f, f, void 0 !== u.ownerSVGElement, t && !i ? [t] : o ? null : e.slice.call(u.childNodes), c, !1, t || f, i), j(c, l);
}

function L(n, l) {
  I(n, l, r);
}

function M(n, l) {
  return l = s(s({}, n.props), l), arguments.length > 2 && (l.children = e.slice.call(arguments, 2)), v(n.type, l, l.key || n.key, l.ref || n.ref);
}

function O(n) {
  var l = {},
      u = {
    __c: "__cC" + o++,
    __p: n,
    Consumer: function (n, l) {
      return n.children(l);
    },
    Provider: function (n) {
      var t,
          i = this;
      return this.getChildContext || (t = [], this.getChildContext = function () {
        return l[u.__c] = i, l;
      }, this.shouldComponentUpdate = function (i) {
        n.value !== i.value && (l[u.__c].props.value = i.value, t.some(function (n) {
          n.__P && (n.context = i.value, k(n));
        }));
      }, this.sub = function (n) {
        t.push(n);
        var l = n.componentWillUnmount;

        n.componentWillUnmount = function () {
          t.splice(t.indexOf(n), 1), l && l.call(n);
        };
      }), n.children;
    }
  };
  return u.Consumer.contextType = u, u;
}

exports.options = n = {}, exports.isValidElement = l = function (n) {
  return null != n && void 0 === n.constructor;
}, m.prototype.setState = function (n, l) {
  var u = this.__s !== this.state && this.__s || (this.__s = s({}, this.state));
  ("function" != typeof n || (n = n(u, this.props))) && s(u, n), null != n && this.__v && (this.u = !1, l && this.__h.push(l), k(this));
}, m.prototype.forceUpdate = function (n) {
  this.__v && (n && this.__h.push(n), this.u = !0, k(this));
}, m.prototype.render = d, u = [], t = "function" == typeof Promise ? Promise.prototype.then.bind(Promise.resolve()) : setTimeout, i = n.debounceRendering, n.__e = function (n, l, u) {
  for (var t; l = l.__p;) if ((t = l.__c) && !t.__p) try {
    if (t.constructor && null != t.constructor.getDerivedStateFromError) t.setState(t.constructor.getDerivedStateFromError(n));else {
      if (null == t.componentDidCatch) continue;
      t.componentDidCatch(n);
    }
    return k(t.__E = t);
  } catch (l) {
    n = l;
  }

  throw n;
}, r = f, o = 0;
},{}],"Mw+g":[function(require,module,exports) {
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useState = c;
exports.useReducer = a;
exports.useEffect = v;
exports.useLayoutEffect = m;
exports.useRef = d;
exports.useImperativeHandle = p;
exports.useMemo = l;
exports.useCallback = s;
exports.useContext = y;
exports.useDebugValue = _;

var _preact = require("preact");

var t,
    r,
    u = [],
    i = _preact.options.__r;

_preact.options.__r = function (n) {
  i && i(n), t = 0, (r = n.__c).__H && (r.__H.t = A(r.__H.t));
};

var f = _preact.options.diffed;

_preact.options.diffed = function (n) {
  f && f(n);
  var t = n.__c;

  if (t) {
    var r = t.__H;
    r && (r.u = (r.u.some(function (n) {
      n.ref && (n.ref.current = n.createHandle());
    }), []), r.i = A(r.i));
  }
};

var o = _preact.options.unmount;

function e(t) {
  _preact.options.__h && _preact.options.__h(r);
  var u = r.__H || (r.__H = {
    o: [],
    t: [],
    i: [],
    u: []
  });
  return t >= u.o.length && u.o.push({}), u.o[t];
}

function c(n) {
  return a(q, n);
}

function a(n, u, i) {
  var f = e(t++);
  return f.__c || (f.__c = r, f.v = [i ? i(u) : q(void 0, u), function (t) {
    var r = n(f.v[0], t);
    f.v[0] !== r && (f.v[0] = r, f.__c.setState({}));
  }]), f.v;
}

function v(n, u) {
  var i = e(t++);
  h(i.m, u) && (i.v = n, i.m = u, r.__H.t.push(i), T(r));
}

function m(n, u) {
  var i = e(t++);
  h(i.m, u) && (i.v = n, i.m = u, r.__H.i.push(i));
}

function d(n) {
  return l(function () {
    return {
      current: n
    };
  }, []);
}

function p(n, u, i) {
  var f = e(t++);
  h(f.m, i) && (f.m = i, r.__H.u.push({
    ref: n,
    createHandle: u
  }));
}

function l(n, r) {
  var u = e(t++);
  return h(u.m, r) ? (u.m = r, u.p = n, u.v = n()) : u.v;
}

function s(n, t) {
  return l(function () {
    return n;
  }, t);
}

function y(n) {
  var u = r.context[n.__c];
  if (!u) return n.__p;
  var i = e(t++);
  return null == i.v && (i.v = !0, u.sub(r)), u.props.value;
}

function _(t, r) {
  _preact.options.useDebugValue && _preact.options.useDebugValue(r ? r(t) : t);
}

_preact.options.unmount = function (n) {
  o && o(n);
  var t = n.__c;

  if (t) {
    var r = t.__H;
    r && r.o.forEach(function (n) {
      return n.l && n.l();
    });
  }
};

var T = function () {};

function g() {
  u.some(function (n) {
    n.s = !1, n.__P && (n.__H.t = A(n.__H.t));
  }), u = [];
}

if ("undefined" != typeof window) {
  var w = _preact.options.requestAnimationFrame;

  T = function (t) {
    (!t.s && (t.s = !0) && 1 === u.push(t) || w !== _preact.options.requestAnimationFrame) && (w = _preact.options.requestAnimationFrame, (_preact.options.requestAnimationFrame || function (n) {
      var t = function () {
        clearTimeout(r), cancelAnimationFrame(u), setTimeout(n);
      },
          r = setTimeout(t, 100),
          u = requestAnimationFrame(t);
    })(g));
  };
}

function A(n) {
  return n.forEach(E), n.forEach(F), [];
}

function E(n) {
  n.l && n.l();
}

function F(n) {
  var t = n.v();
  "function" == typeof t && (n.l = t);
}

function h(n, t) {
  return !n || t.some(function (t, r) {
    return t !== n[r];
  });
}

function q(n, t) {
  return "function" == typeof t ? t(n) : t;
}
},{"preact":"1aSo"}],"kInV":[function(require,module,exports) {
module.exports = "logo_with_text.b9066682.svg";
},{}],"iLFA":[function(require,module,exports) {
module.exports = "logo_with_text_creator.c4c327bb.svg";
},{}],"FjYp":[function(require,module,exports) {
module.exports = "printer.cee77f35.svg";
},{}],"COHl":[function(require,module,exports) {
module.exports = "step_1.5f18dd00.svg";
},{}],"YcY9":[function(require,module,exports) {
module.exports = "step_2.40f7ef5b.svg";
},{}],"NsGV":[function(require,module,exports) {
module.exports = "step_3.53ff3351.svg";
},{}],"yW/P":[function(require,module,exports) {
module.exports = "up.490f5342.svg";
},{}],"225E":[function(require,module,exports) {
module.exports = "down.90970fea.svg";
},{}],"bpjs":[function(require,module,exports) {
module.exports = "delete.615b3509.svg";
},{}],"O4Kh":[function(require,module,exports) {
module.exports = "add.6b022363.svg";
},{}],"T1be":[function(require,module,exports) {
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
Object.defineProperty(exports, "logoWithText", {
  enumerable: true,
  get: function () {
    return _logo_with_text.default;
  }
});
Object.defineProperty(exports, "logoWithTextCreator", {
  enumerable: true,
  get: function () {
    return _logo_with_text_creator.default;
  }
});
Object.defineProperty(exports, "printerIcon", {
  enumerable: true,
  get: function () {
    return _printer.default;
  }
});
Object.defineProperty(exports, "instructionsStep1", {
  enumerable: true,
  get: function () {
    return _step_.default;
  }
});
Object.defineProperty(exports, "instructionsStep2", {
  enumerable: true,
  get: function () {
    return _step_2.default;
  }
});
Object.defineProperty(exports, "instructionsStep3", {
  enumerable: true,
  get: function () {
    return _step_3.default;
  }
});
Object.defineProperty(exports, "upIcon", {
  enumerable: true,
  get: function () {
    return _up.default;
  }
});
Object.defineProperty(exports, "downIcon", {
  enumerable: true,
  get: function () {
    return _down.default;
  }
});
Object.defineProperty(exports, "deleteIcon", {
  enumerable: true,
  get: function () {
    return _delete.default;
  }
});
Object.defineProperty(exports, "addIcon", {
  enumerable: true,
  get: function () {
    return _add.default;
  }
});

var _logo_with_text = _interopRequireDefault(require("./images/logo_with_text.svg"));

var _logo_with_text_creator = _interopRequireDefault(require("./images/logo_with_text_creator.svg"));

var _printer = _interopRequireDefault(require("./images/printer.svg"));

var _step_ = _interopRequireDefault(require("./images/step_1.svg"));

var _step_2 = _interopRequireDefault(require("./images/step_2.svg"));

var _step_3 = _interopRequireDefault(require("./images/step_3.svg"));

var _up = _interopRequireDefault(require("./images/up.svg"));

var _down = _interopRequireDefault(require("./images/down.svg"));

var _delete = _interopRequireDefault(require("./images/delete.svg"));

var _add = _interopRequireDefault(require("./images/add.svg"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
},{"./images/logo_with_text.svg":"kInV","./images/logo_with_text_creator.svg":"iLFA","./images/printer.svg":"FjYp","./images/step_1.svg":"COHl","./images/step_2.svg":"YcY9","./images/step_3.svg":"NsGV","./images/up.svg":"yW/P","./images/down.svg":"225E","./images/delete.svg":"bpjs","./images/add.svg":"O4Kh"}],"fxRm":[function(require,module,exports) {

},{}],"blM5":[function(require,module,exports) {
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = SecretEntryForm;

var _preact = require("preact");

var _hooks = require("preact/hooks");

var _images = require("./images.js");

require("./SecretEntryForm.less");

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) { return; } var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

/**
 * Initial reducer state for the secret entry form.
 *
 * Structure:
 *
 * {
 *   description: "...",
 *   secrets: [
 *     {name: "...", description: "...", secret: "...", obscureLength: bool, key: number},
 *     ...
 *   ],
 * }
 *
 * Where All fields are as you might expect and 'key' is a unique ID to help
 * preact track secrets when they're re-ordered.
 */
var initialState = {
  description: "",
  secrets: [{
    name: "",
    description: "",
    secret: "",
    obscureLength: true,
    key: -1
  }]
};
/**
 * Given a secrets array from the reducer state, return a new array with
 * elements indexed i and j swapped.
 */

function swapSecrets(oldSecrets, i, j) {
  var secrets = oldSecrets.slice();
  secrets.splice.apply(secrets, [j, 0].concat(_toConsumableArray(secrets.splice(i, 1))));
  return secrets;
}
/**
 * Modify a secret in the reducer state secrets array. Takes an object which
 * will be merged into the secret with index 'i'. Returns a new, modified
 * array.
 */


function updateSecret(oldSecrets, i, update) {
  var secrets = oldSecrets.slice();
  secrets[i] = _objectSpread({}, secrets[i], {}, update);
  return secrets;
}
/**
 * Reducer for the secret entry form.
 */


function reduce(state, action) {
  switch (action.type) {
    case "set-pad-description":
      return _objectSpread({}, state, {
        description: action.value
      });

    case "add-secret":
      return _objectSpread({}, state, {
        secrets: state.secrets.concat([{
          name: "",
          description: "",
          secret: "",
          obscureLength: true,
          key: Math.random()
        }])
      });

    case "delete-secret":
      if (window.confirm("Are you sure you want to delete '".concat(state.secrets[action.number].name, "'?"))) {
        var newSecrets = state.secrets.slice();
        newSecrets.splice(action.number, 1);
        return _objectSpread({}, state, {
          secrets: newSecrets
        });
      } else {
        return state;
      }

    case "move-secret-up":
      if (action.number > 0) {
        return _objectSpread({}, state, {
          secrets: swapSecrets(state.secrets, action.number, action.number - 1)
        });
      } else {
        return state;
      }

    case "move-secret-down":
      if (action.number < state.secrets.length - 1) {
        return _objectSpread({}, state, {
          secrets: swapSecrets(state.secrets, action.number, action.number + 1)
        });
      } else {
        return state;
      }

    case "set-name":
      return _objectSpread({}, state, {
        secrets: updateSecret(state.secrets, action.number, {
          name: action.value
        })
      });

    case "set-description":
      return _objectSpread({}, state, {
        secrets: updateSecret(state.secrets, action.number, {
          description: action.value
        })
      });

    case "set-secret":
      return _objectSpread({}, state, {
        secrets: updateSecret(state.secrets, action.number, {
          secret: action.value
        })
      });

    case "set-obscure-length":
      return _objectSpread({}, state, {
        secrets: updateSecret(state.secrets, action.number, {
          obscureLength: action.value
        })
      });

    default:
      return state;
  }
}
/**
 * An input for a single secret.
 *
 * * number: The secret index in the secrets array.
 * * name: The name field value.
 * * description: The description field value.
 * * secret: The secret field value.
 * * obscureLength: The obscure length field value.
 * * dispatch: The dispatch function to use to store changes.
 */


function SecretInput(_ref) {
  var number = _ref.number,
      name = _ref.name,
      description = _ref.description,
      secret = _ref.secret,
      obscureLength = _ref.obscureLength,
      dispatch = _ref.dispatch;

  var _useState = (0, _hooks.useState)(false),
      _useState2 = _slicedToArray(_useState, 2),
      showSecret = _useState2[0],
      setShowSecret = _useState2[1];

  return (0, _preact.h)("div", {
    className: "SecretInput"
  }, (0, _preact.h)("label", {
    title: "A short message stating what this secret is."
  }, (0, _preact.h)("span", null, "Title:"), (0, _preact.h)("input", {
    type: "text",
    autocomplete: "off",
    value: name,
    onInput: function onInput(evt) {
      return dispatch({
        type: "set-name",
        number: number,
        value: evt.target.value
      });
    }
  })), (0, _preact.h)("label", {
    className: "description-entry"
  }, (0, _preact.h)("span", null, "Description:"), (0, _preact.h)("textarea", {
    onInput: function onInput(evt) {
      return dispatch({
        type: "set-description",
        number: number,
        value: evt.target.value
      });
    },
    placeholder: "(optional) e.g. login instructions"
  }, description)), (0, _preact.h)("label", {
    title: "The secret to be encrypted."
  }, (0, _preact.h)("span", null, "Secret:"), (0, _preact.h)("div", {
    className: "secret-box"
  }, (0, _preact.h)("input", {
    type: showSecret ? "text" : "password",
    autocomplete: "off",
    value: secret,
    onInput: function onInput(evt) {
      return dispatch({
        type: "set-secret",
        number: number,
        value: evt.target.value
      });
    }
  }), (0, _preact.h)("label", {
    title: "Toggle secret visibility. (The secret will always be shown encrypted on the secret sharing pads produced.)"
  }, (0, _preact.h)("input", {
    type: "checkbox",
    autocomplete: "off",
    checked: showSecret ? "true" : "",
    onInput: function onInput(evt) {
      return setShowSecret(!showSecret);
    }
  }), (0, _preact.h)("span", null, "Show")))), (0, _preact.h)("label", {
    title: "Add a random amount of padding to the encrypted secret to conceal its length."
  }, (0, _preact.h)("span", null), (0, _preact.h)("div", {
    className: "obscure-length-option"
  }, (0, _preact.h)("input", {
    type: "checkbox",
    autocomplete: "off",
    checked: obscureLength ? "true" : "",
    onInput: function onInput(evt) {
      return dispatch({
        type: "set-obscure-length",
        number: number,
        value: evt.target.checked
      });
    }
  }), (0, _preact.h)("span", null, "Obscure length of encrypted secret on pad"))));
}
/**
 * An editor for a list of secrets
 *
 * * secrets: An array of secret objects from the reducer store.
 * * dispatch: The dispatch function to use to store changes.
 */


function SecretList(_ref2) {
  var secrets = _ref2.secrets,
      dispatch = _ref2.dispatch;
  return (0, _preact.h)("div", {
    className: "SecretList"
  }, secrets.map(function (secret, number) {
    return (0, _preact.h)("div", {
      className: "secret",
      key: secret.key
    }, (0, _preact.h)(SecretInput, _extends({
      number: number,
      dispatch: dispatch
    }, secret)), (0, _preact.h)("div", {
      className: "buttons"
    }, (0, _preact.h)("button", {
      className: "move-up",
      title: "Move secret up",
      style: {
        visibility: number === 0 ? "hidden" : "visible"
      },
      onClick: function onClick() {
        return dispatch({
          type: "move-secret-up",
          number: number
        });
      }
    }, (0, _preact.h)("img", {
      src: _images.upIcon,
      alt: "Move Up"
    })), (0, _preact.h)("button", {
      className: "delete",
      title: "Delete secret",
      onClick: function onClick() {
        return dispatch({
          type: "delete-secret",
          number: number
        });
      }
    }, (0, _preact.h)("img", {
      src: _images.deleteIcon,
      alt: "Delete"
    })), (0, _preact.h)("button", {
      className: "move-down",
      title: "Move secret down",
      style: {
        visibility: number === secrets.length - 1 ? "hidden" : "visible"
      },
      onClick: function onClick() {
        return dispatch({
          type: "move-secret-down",
          number: number
        });
      }
    }, (0, _preact.h)("img", {
      src: _images.downIcon,
      alt: "Move Down"
    }))));
  }), (0, _preact.h)("div", {
    className: "add-button-area"
  }, (0, _preact.h)("button", {
    className: "add-button",
    onClick: function onClick() {
      return dispatch({
        type: "add-secret"
      });
    }
  }, (0, _preact.h)("img", {
    src: _images.addIcon,
    alt: "Plus Symbol"
  }), (0, _preact.h)("span", null, "Add Secret"))));
}
/**
 * Show the children in a page-style box on the screen.
 */


function Page(_ref3) {
  var children = _ref3.children;
  return (0, _preact.h)("div", {
    className: "Page"
  }, (0, _preact.h)("div", {
    className: "inner"
  }, children));
}
/**
 * A form which provides instructions and allows a user to fill secrets to be
 * encrypted.
 *
 * * onCreatePad: A function to call when the 'create pads' button is pressed.
 *   Will be passed three arguments: the number of pads to create, the pad
 *   description string and the secrets to be encrypted.
 */


function SecretEntryForm(_ref4) {
  var onCreatePad = _ref4.onCreatePad;

  var _useReducer = (0, _hooks.useReducer)(reduce, initialState),
      _useReducer2 = _slicedToArray(_useReducer, 2),
      _useReducer2$ = _useReducer2[0],
      description = _useReducer2$.description,
      secrets = _useReducer2$.secrets,
      dispatch = _useReducer2[1];

  var _useState3 = (0, _hooks.useState)(2),
      _useState4 = _slicedToArray(_useState3, 2),
      numberOfPads = _useState4[0],
      setNumberOfPads = _useState4[1];

  return (0, _preact.h)(Page, null, (0, _preact.h)("div", {
    className: "SecretEntryForm"
  }, (0, _preact.h)("div", {
    className: "section introduction"
  }, (0, _preact.h)("h1", null, (0, _preact.h)("img", {
    className: "logo",
    src: _images.logoWithTextCreator,
    alt: "Secret Sharing Pad"
  })), (0, _preact.h)("div", {
    className: "warning"
  }, (0, _preact.h)("strong", null, "Information entered below will not be saved or leave your computer."))), (0, _preact.h)("div", {
    className: "section description"
  }, (0, _preact.h)("label", null, (0, _preact.h)("h2", null, "Special instructions to show on every pad"), (0, _preact.h)("textarea", {
    onInput: function onInput(evt) {
      return dispatch({
        type: "set-pad-description",
        value: evt.target.value
      });
    },
    placeholder: "e.g. who created the pad, when should it be used"
  }, description))), (0, _preact.h)("div", {
    className: "section secret-list"
  }, (0, _preact.h)("h2", null, "Secrets"), (0, _preact.h)(SecretList, {
    dispatch: dispatch,
    secrets: secrets
  })), (0, _preact.h)("div", {
    className: "section create-pads-section"
  }, (0, _preact.h)("div", {
    className: "submission-bar"
  }, (0, _preact.h)("label", {
    className: "number-of-pads"
  }, (0, _preact.h)("span", null, "Number of pads:"), (0, _preact.h)("input", {
    title: "Number of secret sharing pads to create",
    type: "number",
    value: numberOfPads,
    onInput: function onInput(evt) {
      return setNumberOfPads(evt.target.value);
    },
    min: "2",
    max: "26"
  })), (0, _preact.h)("button", {
    className: "create-button",
    onClick: function onClick() {
      return onCreatePad(numberOfPads, description, secrets);
    }
  }, "Create Secret Sharing Pads")))));
}
},{"preact":"1aSo","preact/hooks":"Mw+g","./images.js":"T1be","./SecretEntryForm.less":"fxRm"}],"LBCC":[function(require,module,exports) {
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = SecretSharingPads;

var _preact = require("preact");

require("./SecretSharingPads.less");

var _images = require("./images.js");

/**
 * A complete set of secret sharing pads, ready for printing.
 *
 * Props:
 * * padId: The unique ID identifying the set of secret sharing pads.
 * * padColours: A lookup {letter: colour, ...} giving the colour to use for
 *   each pad letter.
 * * description: Any introductory notes from the pad author to display.
 * * allEncryptedSecrets: An array of {letter, [{name, description,
 *   encryptedSecret: [{letter,  code: [n, ...]}, ...]}, ...]} objects.  For
 *   each lettered pad, gives the secret to be displayed gives the name and
 *   description string and encrypted secrets. Each encrypted secret is given
 *   as an array of encoded values and their associated letters.
 */
function SecretSharingPads(_ref) {
  var padId = _ref.padId,
      padColours = _ref.padColours,
      description = _ref.description,
      allEncryptedSecrets = _ref.allEncryptedSecrets;
  return (0, _preact.h)("div", {
    className: "SecretSharingPads"
  }, (0, _preact.h)("div", {
    className: "print-button"
  }, (0, _preact.h)(PrintHint, null)), (0, _preact.h)("div", {
    className: "pads"
  }, allEncryptedSecrets.map(function (_ref2) {
    var letter = _ref2.letter,
        encryptedSecrets = _ref2.encryptedSecrets;
    return (0, _preact.h)(SecretSharingPad, {
      padId: padId,
      padLetter: letter,
      padColours: padColours,
      description: description,
      encryptedSecrets: encryptedSecrets
    });
  })));
}
/**
 * Given a string with paragraphs separated by newlines, output each in a new
 * <p> tag.
 */


function stringToParagraphs(str) {
  return str.trim().split(/[\n]+/).map(function (line) {
    return (0, _preact.h)("p", null, line);
  });
}
/**
 * A single secret sharing pad, ready for printing.
 *
 * Props:
 * * padId: The unique ID identifying the set of secret sharing pads.
 * * padLetter: The letter for this pad.
 * * padColours: A lookup {letter: colour, ...} giving the colour to use for
 *   each pad letter.
 * * description: Any introductory notes from the pad author to display.
 * * encryptedSecrets: An array of {name, description, encryptedSecret: [{letter,  code: [n,
 *   ...]}, ...]} objects.  For each secret to be displayed gives the name and
 *   description string and encrypted secrets. Each encrypted secret is given
 *   as an array of encoded values and their associated letters.
 */


function SecretSharingPad(_ref3) {
  var padId = _ref3.padId,
      padLetter = _ref3.padLetter,
      padColours = _ref3.padColours,
      description = _ref3.description,
      encryptedSecrets = _ref3.encryptedSecrets;
  var colour = padColours[padLetter];
  return (0, _preact.h)("div", {
    className: "SecretSharingPad"
  }, (0, _preact.h)("div", {
    className: "inner"
  }, (0, _preact.h)(Header, {
    padId: padId,
    padLetter: padLetter,
    colour: colour
  }), stringToParagraphs(description), (0, _preact.h)(Instructions, {
    padId: padId,
    padLetter: padLetter
  }), (0, _preact.h)(EncryptedSecrets, {
    encryptedSecrets: encryptedSecrets,
    padColours: padColours
  })));
}

;
/**
 * The header bar shown on the first page of each secret sharing pads.
 *
 * Props:
 * * padId: The unique ID identifying the set of secret sharing pads.
 * * padLetter: The letter for this pad.
 * * colour: The colour to use for this pad.
 */

function Header(_ref4) {
  var padId = _ref4.padId,
      padLetter = _ref4.padLetter,
      colour = _ref4.colour;
  return (0, _preact.h)("header", {
    className: "Header"
  }, (0, _preact.h)("div", {
    className: "inner"
  }, (0, _preact.h)("h1", null, (0, _preact.h)("img", {
    src: _images.logoWithText,
    alt: "Secret Sharing Pad"
  })), (0, _preact.h)("div", {
    class: "pad-id"
  }, "Pad number:", (0, _preact.h)(PadIdBadge, {
    padId: padId,
    padLetter: padLetter,
    colour: colour
  }))));
}
/**
 * A badge showing the pad ID and letter.
 *
 * Props:
 * * padId: The unique ID identifying the set of secret sharing pads.
 * * padLetter: The letter for this pad.
 * * colour: The colour to use for this pad.
 */


function PadIdBadge(_ref5) {
  var padId = _ref5.padId,
      padLetter = _ref5.padLetter,
      colour = _ref5.colour;
  return (0, _preact.h)("div", {
    className: "PadIdBadge"
  }, (0, _preact.h)("span", {
    class: "number",
    style: {
      backgroundColor: colour
    }
  }, (0, _preact.h)("span", {
    class: "id"
  }, padId), (0, _preact.h)("span", {
    class: "letter"
  }, padLetter)));
}

function Instructions(_ref6) {
  var padId = _ref6.padId,
      padLetter = _ref6.padLetter;
  return (0, _preact.h)("div", {
    className: "Instructions"
  }, (0, _preact.h)("h2", null, "Decryption instructions"), (0, _preact.h)("div", {
    className: "steps"
  }, (0, _preact.h)("div", {
    className: "step"
  }, (0, _preact.h)("img", {
    src: _images.instructionsStep1
  }), (0, _preact.h)("p", null, "Obtain another secret sharing pad with the same pad number as this one, but different letter, printed at the top right. Find the secret you want to decrypt on both pads.")), (0, _preact.h)("div", {
    className: "step"
  }, (0, _preact.h)("img", {
    src: _images.instructionsStep2
  }), (0, _preact.h)("p", null, "Find the list of three-digit codes printed next to the letter of the other pad. Working left-to-right, add the codes on the first pad to the codes on the second pad and write down the answers.")), (0, _preact.h)("div", {
    className: "step"
  }, (0, _preact.h)("img", {
    src: _images.instructionsStep3
  }), (0, _preact.h)("p", null, "Use the table above to turn the last three digits of each sum into a character. Stop when you find a sum whose last three digits are '000'. The remaining codes just hide the secret's real length."))), (0, _preact.h)("p", null, (0, _preact.h)("strong", null, "Troubleshooting:"), " The last three digits of summed codes should be either 000 or between 032 and 126. If this is not the case, check the pad numbers match and that you're looking at the correct list of codes. Check your steps against the example in the pictures above."), (0, _preact.h)("p", null, (0, _preact.h)("strong", null, "Using spreadsheet (optional):"), " Copy the three-digit codes for your two pads into columns A and B of your spreadsheet. Type", " ", (0, _preact.h)("code", null, "=MOD(A1+B1, 1000)"), " into cell C1 and ", (0, _preact.h)("code", null, "=CHAR(C1)"), " into cell D1. Use auto-fill to repeat the formulae in columns C and D over the remaining rows."));
}
/**
 * A list of encrypted secrets
 *
 * Props:
 * * encryptedSecrets: An array of {name, description, encryptedSecret:
 *   [{letter,  code: [n, ...]}, ...]} objects.
 * * padColours: A lookup {letter: colour, ...}.
 */


function EncryptedSecrets(_ref7) {
  var padColours = _ref7.padColours,
      encryptedSecrets = _ref7.encryptedSecrets;
  return (0, _preact.h)("div", {
    class: "EncryptedSecrets"
  }, encryptedSecrets.map(function (_ref8, i) {
    var name = _ref8.name,
        description = _ref8.description,
        encryptedSecret = _ref8.encryptedSecret;
    return (0, _preact.h)(EncryptedSecret, {
      name: name,
      number: i + 1,
      description: description,
      encryptedSecret: encryptedSecret,
      padColours: padColours
    });
  }));
}
/**
 * A single encrypted secret in an <EncryptedSecrets> container.
 *
 * Props:
 * * number The secret number
 * * name The secret name
 * * description The secret description
 * * encryptedSecrets: An array of {name, description, encryptedSecret:
 *   [{letter,  code: [n, ...]}, ...]} objects.
 * * padColours: A lookup {letter: colour, ...}.
 */


function EncryptedSecret(_ref9) {
  var number = _ref9.number,
      name = _ref9.name,
      description = _ref9.description,
      encryptedSecret = _ref9.encryptedSecret,
      padColours = _ref9.padColours;
  return (0, _preact.h)("article", {
    className: "EncryptedSecret"
  }, (0, _preact.h)("h2", null, "Secret ", number, ": ", name), stringToParagraphs(description), (0, _preact.h)("div", {
    className: "encrypted-secrets"
  }, encryptedSecret.map(function (_ref10) {
    var letter = _ref10.letter,
        code = _ref10.code;
    return (0, _preact.h)("div", {
      className: "secret"
    }, (0, _preact.h)("div", {
      class: "letter",
      style: {
        color: padColours[letter],
        borderColor: padColours[letter]
      }
    }, letter), (0, _preact.h)("div", {
      class: "code"
    }, code.map(function (n) {
      return n.toString().padStart(3, '0');
    }).join(" ")));
  })));
}

function PrintHint() {
  return (0, _preact.h)("div", {
    className: "PrintHint"
  }, (0, _preact.h)("button", {
    onClick: function onClick() {
      return window.print();
    },
    title: "Print all pads"
  }, (0, _preact.h)("img", {
    src: _images.printerIcon,
    alt: "Print"
  })), (0, _preact.h)("span", null, "Warning: These pads will be shown only once."));
}
},{"preact":"1aSo","./SecretSharingPads.less":"fxRm","./images.js":"T1be"}],"gsVa":[function(require,module,exports) {
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.cryptoRandInt = cryptoRandInt;
exports.encryptAsciiChar = encryptAsciiChar;
exports.encryptString = encryptString;
exports.randomlyPadString = randomlyPadString;
exports.generateSecretSharingPadData = generateSecretSharingPadData;

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) { return; } var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

/**
 * Logic for encrypting secrets for use on a secret sharing pad.
 */

/**
 * Generate unbiased random integers between lo and hi (inclusive) using
 * Crypto.getRandomValues().
 *
 * Range is limited to 30-bits (~1 billion).
 */
function cryptoRandInt(lo, hi) {
  var range = hi - lo + 1;
  var mask = (1 << 30) - 1;
  var randomMax = Math.floor((1 << 30) / range) * range;
  var a = new Uint32Array(1);
  var firstIteration = true;

  while (a[0] & mask >= randomMax || firstIteration) {
    firstIteration = false;
    window.crypto.getRandomValues(a);
  }

  var value = (a[0] & mask) % range;
  return lo + value;
}
/**
 * Encrypt a character as a pair of numbers in the range 0-999 inclusive.
 */


function encryptAsciiChar(c) {
  var charCode = c.charCodeAt(0);

  if (charCode != 0 && (charCode < 32 || charCode > 126)) {
    throw "Character is not a printable ASCII character or NULL.";
  }

  var randomNumber = cryptoRandInt(0, 999);
  return [randomNumber, (1000 + charCode - randomNumber) % 1000];
}
/**
 * Encrypt a string, return the two number sequences.
 */


function encryptString(s) {
  var a1 = [];
  var a2 = [];

  for (var i = 0; i < s.length; i++) {
    var _encryptAsciiChar = encryptAsciiChar(s[i]),
        _encryptAsciiChar2 = _slicedToArray(_encryptAsciiChar, 2),
        v1 = _encryptAsciiChar2[0],
        v2 = _encryptAsciiChar2[1];

    a1.push(v1);
    a2.push(v2);
  }

  return [a1, a2];
}
/**
 * Add a random number of null characters to the end of the supplied string.
 * The length of the string may be increased by up to double its original
 * length.
 */


function randomlyPadString(s) {
  var padLength = cryptoRandInt(s.length, s.length * 2);
  return s.padEnd(padLength, "\0");
}
/**
 * Generate a datastructure defining a set of secret sharing pads.
 *
 * @param secrets An array of {name, description, secret, obscureLength} objects defining
 *        the complete set of secrets to encrypt.
 * @param letters An array of letters to use to identify the pads over which
 *        the secrets will be shared.
 *
 * @return [
 *    {
 *        letter,
 *        encryptedSecrets: [
 *            {
 *                name,
 *                description,
 *                encryptedSecret: [{letter, code: [n, ...]}, ...],
 *            },
 *            ...
 *        ],
 *    },
 *    ...
 * ]
 */


function generateSecretSharingPadData(secrets, letters) {
  var out = letters.map(function (letter) {
    return {
      letter: letter,
      encryptedSecrets: secrets.map(function (_ref) {
        var name = _ref.name,
            description = _ref.description;
        return {
          name: name,
          description: description,
          encryptedSecret: []
        };
      })
    };
  });

  for (var secretNo = 0; secretNo < secrets.length; secretNo++) {
    var _secrets$secretNo = secrets[secretNo],
        name = _secrets$secretNo.name,
        description = _secrets$secretNo.description,
        secret = _secrets$secretNo.secret,
        obscureLength = _secrets$secretNo.obscureLength;

    if (obscureLength) {
      secret = randomlyPadString(secret);
    }

    for (var letterNo1 = 0; letterNo1 < letters.length; letterNo1++) {
      for (var letterNo2 = letterNo1 + 1; letterNo2 < letters.length; letterNo2++) {
        var _encryptString = encryptString(secret),
            _encryptString2 = _slicedToArray(_encryptString, 2),
            code1 = _encryptString2[0],
            code2 = _encryptString2[1];

        out[letterNo1].encryptedSecrets[secretNo].encryptedSecret.push({
          letter: letters[letterNo2],
          code: code1
        });
        out[letterNo2].encryptedSecrets[secretNo].encryptedSecret.push({
          letter: letters[letterNo1],
          code: code2
        });
      }
    }
  }

  return out;
}
},{}],"/deH":[function(require,module,exports) {
"use strict";

var _preact = require("preact");

var _SecretEntryForm = _interopRequireDefault(require("./SecretEntryForm.jsx"));

var _SecretSharingPads = _interopRequireDefault(require("./SecretSharingPads.jsx"));

var _encrypt = require("./encrypt.js");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function createPad(numberOfPads, description, secrets) {
  var padId = (0, _encrypt.cryptoRandInt)(0, 999999).toString().padStart(6, "0"); // Assign letters and colours for each pad

  var letters = [];
  var padColours = {};

  for (var i = 0; i < numberOfPads; i++) {
    var letter = String.fromCharCode("A".charCodeAt(0) + i);
    letters.push(letter);
    padColours[letter] = "hsl(".concat(Math.round(360 * (i / numberOfPads)), ", 100%, 40%)");
  }

  var allEncryptedSecrets = (0, _encrypt.generateSecretSharingPadData)(secrets, letters); // Create window for generated pads

  var padWindow = window.open("", padId);
  padWindow.document.write("<html><head></head><body></body></html>");
  padWindow.document.title = "Secret Sharing Pad ".concat(padId);
  var padWindowHead = padWindow.document.getElementsByTagName("head")[0];
  var padWindowBody = padWindow.document.getElementsByTagName("body")[0]; // Copy all CSS from this page

  var _iteratorNormalCompletion = true;
  var _didIteratorError = false;
  var _iteratorError = undefined;

  try {
    for (var _iterator = document.getElementsByTagName("link")[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
      var link = _step.value;
      var linkCopy = padWindow.document.importNode(link, true);
      padWindowHead.appendChild(linkCopy);
    } // Show the pads in the window and trigger a print

  } catch (err) {
    _didIteratorError = true;
    _iteratorError = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion && _iterator.return != null) {
        _iterator.return();
      }
    } finally {
      if (_didIteratorError) {
        throw _iteratorError;
      }
    }
  }

  (0, _preact.render)((0, _preact.h)(_SecretSharingPads.default, {
    padId: padId,
    padColours: padColours,
    description: description,
    allEncryptedSecrets: allEncryptedSecrets
  }), padWindowBody);
}

(0, _preact.render)((0, _preact.h)(_SecretEntryForm.default, {
  onCreatePad: createPad
}), document.getElementById("root"));
},{"preact":"1aSo","./SecretEntryForm.jsx":"blM5","./SecretSharingPads.jsx":"LBCC","./encrypt.js":"gsVa"}]},{},["/deH"], null)
//# sourceMappingURL=src.f856a8cf.js.map